--- qgdict.cpp.old	2007-11-04 15:14:06.000000000 -0500
+++ qgdict.cpp	2007-11-04 15:31:24.000000000 -0500
@@ -397,16 +397,30 @@
 {
     QAsciiBucket *n;
     int	index = hashKeyAscii(key) % vlen;
+
+    if ( vec == NULL )
+    {
+        qFatal( "QAsciiDict: pointer 'vec' is NULL.  Program must exit." );
+    }
+
     if ( op == op_find ) {			// find
 	if ( cases ) {
 	    for ( n=(QAsciiBucket*)vec[index]; n;
 		  n=(QAsciiBucket*)n->getNext() ) {
+		/* Check for NULL.  If NULL, we can't continue looking. */
+		if ( n == NULL )
+			break;
+		/* Check to see if we found the item. */
 		if ( qstrcmp(n->getKey(),key) == 0 )
 		    return n->getData();	// item found
 	    }
 	} else {
 	    for ( n=(QAsciiBucket*)vec[index]; n;
 		  n=(QAsciiBucket*)n->getNext() ) {
+		/* Check for NULL.  If NULL, we can't continue looking. */
+		if ( n == NULL )
+			break;
+		/* Check to see if we found the item. */
 		if ( qstricmp(n->getKey(),key) == 0 )
 		    return n->getData();	// item found
 	    }
@@ -422,7 +436,9 @@
     CHECK_PTR( n );
 #if defined(CHECK_NULL)
     if ( n->getData() == 0 )
-	qWarning( "QAsciiDict: Cannot insert null item" );
+    {
+	qFatal("QAsciiDict: Cannot insert null item.  Program must now exit.");
+    }
 #endif
     vec[index] = n;
     numItems++;
